import javax.swing.JPanel;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.*;
import java.util.Vector;
import java.awt.Graphics;
import java.awt.event.*;
import javax.swing.BorderFactory;

public class CardComponent extends JPanel implements AbstractComponent{

    int DEPTH = 30;
    // Vector to store the elements on this card.
    Vector elementVector = new Vector();
    // Text area for card name
    javax.swing.JTextField cardName = new javax.swing.JTextField();

    public boolean selected = false;
    public boolean exists = false;
    // Constructor
    public CardComponent(){
	exists = true;
	super.setSize(new java.awt.Dimension(150, 100));
        super.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
        //super.setLocation(p);
        super.setVisible(true);
        super.setLayout(null);
        super.setToolTipText("Card information.");
        //super.setBackground(new java.awt.Color(255, 153, 0));
	super.setBackground(java.awt.Color.lightGray);
	super.setBorder(BorderFactory.createLineBorder(java.awt.Color.lightGray));

	// event handling for the card component
	super.addMouseListener(new java.awt.event.MouseAdapter() {
		public void mouseClicked(java.awt.event.MouseEvent e) {
		    cardComponentMouseClicked(e);
		}
	    });


        cardName.setToolTipText("Card name");
        cardName.setVisible(true);
        cardName.setSize(new java.awt.Dimension(70, 20));
        cardName.setSelectedTextColor(java.awt.SystemColor.textHighlight);
        cardName.setColumns(80);
        cardName.setBackground(java.awt.Color.lightGray);
        cardName.setLocation(new java.awt.Point(getWidth()/2 - 35, 5));

	this.add(cardName);


    }

    public void add(AbstractComponent a){
	//a.setLocation(new Point(5,5));
	//super.add(a);
	Dimension d = ((AbstractComponent) a).getSize();
        if (selected == true){
	    //Dimension d = ((AbstractComponent) a).getSize();
	    if (a instanceof CardComponent && d.getWidth() >= this.getWidth()){
		super.setSize(10 + (new Double(d.getWidth())).intValue(),this.getHeight());
	    }
	    a.setLocation(new Point((this.getWidth() - (new Double(d.getWidth())).intValue())/2 + 2, DEPTH));
	    //System.out.println("card added at : " + (this.getWidth() - (new Double(d.getWidth())).intValue())/2 + "," + DEPTH);
	    DEPTH = DEPTH + 15 + (new Double(d.getHeight())).intValue();
	    if (this.getHeight() < DEPTH) {
		super.setSize(new Dimension(this.getWidth(),DEPTH + 10));
	    }
	    if (a instanceof CardComponent){
		elementVector.add((CardComponent) a);
		super.add((CardComponent) a);
	    } else {
		elementVector.add((ElementComponent) a);
		super.add((ElementComponent) a);
	    }
	    //repaint();
	    //System.out.println("size of folder:" + cardName.getText() + " " + elementVector.size());
	}
	for (int i = 0; i < elementVector.size();i++){
	    if (a instanceof CardComponent){
		((AbstractComponent) elementVector.get(i)).add(new CardComponent());
	    } else if(a instanceof ElementComponent) {
		((AbstractComponent) elementVector.get(i)).add(new ElementComponent());
	    }
	}
	rearrange();
	repaint();
    }

    public void rearrange(){
	// we need to find maximum width required and height required.
	Dimension d;
	int maxwidth = 0;
	DEPTH = 30;
	for (int i = 0;i < elementVector.size(); i++){
	    ((AbstractComponent) elementVector.get(i)).rearrange();
	    d = ((AbstractComponent) elementVector.get(i)).getSize();
	    if ((new Double(d.getWidth())).intValue() > maxwidth) maxwidth = (new Double(d.getWidth())).intValue() + 10;
	    ((AbstractComponent) elementVector.get(i)).setLocation(new Point((this.getWidth() - (new Double(d.getWidth())).intValue())/2 + 3, DEPTH));
	    DEPTH = DEPTH + 15 + (new Double(d.getHeight())).intValue();
	    if (this.getHeight() < DEPTH) {
		super.setSize(new Dimension(this.getWidth(),DEPTH + 10));
	    }

	}

	if (DEPTH + 20 < this.getHeight() && DEPTH > 100) {
	    super.setSize(new Dimension(this.getWidth(),DEPTH + 10));
	} else if (DEPTH < 100) {
	    super.setSize(new Dimension(this.getWidth(), 100));
	}
	if (maxwidth >= this.getWidth()){
	    super.setSize(10 + maxwidth,this.getHeight());
	} else if(maxwidth < 150) super.setSize(150,this.getHeight());
	//System.out.println("size of folder:" + cardName.getText() + " " + elementVector.size());
	repaint();
    }

    public void setName(String s){
	cardName.setText(s);
    }

    public void setLocation(Point p){
	super.setLocation(p);
    }

    public void setSize(Dimension d){
	super.setSize(d);
    }

    public Dimension getSize(){
	return super.getSize();
    }

    public void toggleSelect(){
	if (selected){
	    //super.setBackground(new java.awt.Color(255, 153, 0));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.lightGray));
	    selected = false;
	    repaint();
	} else {
	    //super.setBackground(java.awt.Color.magenta);
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.red));
	    selected = true;
	    repaint();
	}
    }

    public void paintComponent(Graphics g){
	int h = getHeight();
	int w = getWidth();
	int[] bxpoints = {0,20,20};
	int[] bypoints = {20,20,0};
	int[] oxpoints = {0,0,20};
	int[] oypoints = {0,20,0};            
	int[] blxpoints = {0,0,30,30}; int[] blypoints = {h-30,h,h,h-30};
	int[] brxpoints = {w-30,w-30,w,w}; int[] brypoints = {h-30,h,h,h-30};
	int[] trxpoints = {w-30,w-30,w,w}; int[] trypoints = {0,30,30,0};
	super.paintComponent(g);	


	//if (selected == true) {
	    g.fillPolygon(bxpoints,bypoints,3);
	    // drawing black border.
	    g.setColor(java.awt.Color.black);
	    g.drawLine(2,20,2,h-2);
	    g.drawLine(2,h-2,w-2,h-2);
	    g.drawLine(20,2,w-2,2);
	    g.drawLine(w-2,2,w-2,h-2);
	    // the following stuff can be used for curved border line.
	    //g.setColor(new java.awt.Color(255,100,0));
	    /*g.setColor(java.awt.Color.lightGray);
	    g.fillPolygon(oxpoints,oypoints,3);
	    g.fillPolygon(blxpoints,blypoints,4);
	    g.fillPolygon(brxpoints,brypoints,4);
	    g.fillPolygon(trxpoints,trypoints,4);
	    g.setColor(java.awt.Color.lightGray);
	    g.fillArc(w - 60, 0, 60, 60, 0, 90);
	    g.fillArc(0,h - 60, 60, 60, 180, 90);
	    g.fillArc(w - 60, h - 60, 60, 60, 270, 90);
	    } else {
	    g.fillPolygon(bxpoints,bypoints,3);
	    g.setColor(new java.awt.Color(255,100,0));
	    g.fillPolygon(oxpoints,oypoints,3);
	    g.fillPolygon(blxpoints,blypoints,4);
	    g.fillPolygon(brxpoints,brypoints,4);
	    g.fillPolygon(trxpoints,trypoints,4);
	    g.setColor(new java.awt.Color(255,153,0));
	    g.fillArc(w - 60, 0, 60, 60, 0, 90);
	    g.fillArc(0,h - 60, 60, 60, 180, 90);
	    g.fillArc(w - 60, h - 60, 60, 60, 270, 90);
	    }*/

    }


    public String genQuery() {
	String name, subquery;
	name = cardName.getText();
	subquery = this.getSubQueries();
	return("(Elem \"" + name + "\" [" + subquery + "])");
    }

    public String getSubQueries(){
	String subQ = "";
	int i;
	for(i=0;i< elementVector.size() - 1; i++){
	    subQ += ((AbstractComponent) elementVector.get(i)).genQuery() + ",";
	}
	if (elementVector.size() > 0)
	subQ += ((AbstractComponent) elementVector.get(i)).genQuery();
	return subQ;
    }

    // updateClick makes sure this Object does not get deleted unless specifically selected
    public void updateClick(){
	selected = false;
    }

    public void mouseEntered(MouseEvent e){ }
    public void mouseExited(MouseEvent e){ }
    public void mousePressed(MouseEvent e){ }
    public void mouseReleased(MouseEvent e){ }


    public void cardComponentMouseClicked(MouseEvent e){    
	//System.out.println("Card clicked: " + cardName.getText());
	if (selected){
	    //super.setBackground(new java.awt.Color(255, 153, 0));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.lightGray));
	    selected = false;
	    repaint();
	} else {
	    //super.setBackground(java.awt.Color.magenta);
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.red));
	    selected = true;
	    repaint();
	}
    }

    public void moved(AbstractComponent a){}

    public boolean isSelected(){
	return selected;
    }

    public void erase(){
	for(int i = 0 ; i < elementVector.size(); i++){
	    if (((AbstractComponent) elementVector.get(i)).isSelected()){
		if(elementVector.get(i) instanceof CardComponent) {
		    super.remove((CardComponent)elementVector.get(i));
		} else if (elementVector.get(i) instanceof ElementComponent) {
		    super.remove((ElementComponent)elementVector.get(i));
		}
		elementVector.removeElementAt(i);
	    } else {
		((AbstractComponent) elementVector.get(i)).erase();
	    }
	}
	//this.rearrange();	
    }

}
	


