import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ErrorDialog extends javax.swing.JDialog {

	// member declarations
	javax.swing.JPanel errorPanel = new javax.swing.JPanel();
	javax.swing.JLabel errorLabel = new javax.swing.JLabel();
	javax.swing.JButton okButton = new javax.swing.JButton();
        String errorString;

	public ErrorDialog(String err) {
	    errorString = err;
	}

	public void initComponents() throws Exception {
		// the following code sets the frame's initial state
		errorPanel.setSize(new java.awt.Dimension(492, 109));
		errorPanel.setBorder(new javax.swing.border.LineBorder(java.awt.Color.black, 1));
		errorPanel.setLocation(new java.awt.Point(0, 0));
		errorPanel.setVisible(true);
		errorPanel.setAlignmentY(0.1F);
		errorPanel.setAlignmentX(0.1F);
		errorPanel.setLayout(null);
		errorPanel.setToolTipText(errorString);
		errorPanel.setBackground(new java.awt.Color(255, 153, 0));
		okButton.setBorder(new javax.swing.plaf.BorderUIResource.BevelBorderUIResource(0));
		okButton.setVisible(true);
		okButton.setSize(new java.awt.Dimension(60, 20));
		okButton.setText("OK");
		okButton.setBackground(new java.awt.Color(255, 153, 0));
		okButton.setLocation(new java.awt.Point(220, 70));
		errorLabel.setSize(new java.awt.Dimension(450, 22));
		errorLabel.setLocation(new java.awt.Point(20, 10));
		errorLabel.setVisible(true);
		errorLabel.setText(errorString);
		errorLabel.setForeground(java.awt.SystemColor.textText);
		errorLabel.setBackground(new java.awt.Color(255, 153, 0));
		setLocation(new java.awt.Point(0, 0));
		getContentPane().setLayout(null);
		getContentPane().setBackground(new java.awt.Color(255, 153, 0));

		errorPanel.add(okButton);
		errorPanel.add(errorLabel);
		getContentPane().add(errorPanel);
		super.setModal(true);
		setSize(new java.awt.Dimension(500, 135));
		//setResizable(false);

		// event handling
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				thisWindowClosing(e);
			}
		});

		okButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				okButtonMouseClicked(e);
			}
		});
	}
  
  	private boolean mShown = false;

	public void okButtonMouseClicked(java.awt.event.MouseEvent e) {
	    setVisible(false);
	    dispose();
	}
  	
	public void addNotify() {
		super.addNotify();
		
		if (mShown)
			return;
			
		// resize frame to account for menubar
		/*JMenuBar jMenuBar = getJMenuBar();
		if (jMenuBar != null) {
			int jMenuBarHeight = jMenuBar.getPreferredSize().height;
			Dimension dimension = getSize();
			dimension.height += jMenuBarHeight;
			setSize(dimension);
			
			// move down components in layered pane
			Component[] components = getLayeredPane().getComponentsInLayer(JLayeredPane.DEFAULT_LAYER.intValue());
			for (int i = 0; i < components.length; i++) {
				Point location = components[i].getLocation();
				location.move(location.x, location.y + jMenuBarHeight);
				components[i].setLocation(location);
			}
			} */

		mShown = true;
	}

	// Close the window when the close box is clicked
	void thisWindowClosing(java.awt.event.WindowEvent e) {
		setVisible(false);
		dispose();
	}
	
}
